#IF 0  ' 

    Windows template for PBwin90

#ENDIF ' 

    #include "project.inc"

' 

FUNCTION PBmain() AS LONG

    LOCAL Wid          as LONG
    LOCAL Hgt          as LONG
    LOCAL wcex         as WNDCLASSEX
    LOCAL szClassName  as ASCIIZ * 32

    global_init

    DisplayName$ = "Windows Application"
    szClassName  = "Application_Class"

  ' ----------------------------------------------------------------------
  ' set the arguments to determine the characteristics of the window class
  ' ----------------------------------------------------------------------
    wcex.cbSize        = SIZEOF(wcex)
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CODEPTR(WndProc)
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = hInstance
    wcex.hIcon         = hIcon
    wcex.hCursor       = LoadCursor(%NULL,ByVal %IDC_ARROW)
    wcex.hbrBackground = %NULL
    wcex.lpszMenuName  = %NULL
    wcex.lpszClassName = VarPtr(szClassName)
    wcex.hIconSm       = hIcon

  ' ---------------------------------------------
  ' register the class with those characteristics
  ' ---------------------------------------------
    RegisterClassEx wcex

  ' -----------------------------------------------
  ' Set Width & Height to percentage of screen size
  ' -----------------------------------------------
    Wid = Sw * .70
    Hgt = Sh * .70

  ' ---------------------------------------
  ' limit the aspect ratio for wide screens
  ' ---------------------------------------
    If Wid > Hgt * 1.4 Then
      Wid = Hgt * 1.4
    End If

  ' ------------------------
  ' Window is self centering
  ' ------------------------
    hWnd = CreateWindowEx( _
           %WS_EX_LEFT, _                  ' extended style
           szClassName, _                  ' window class name
           ByVal StrPtr(DisplayName$), _   ' window title
           %WS_OVERLAPPEDWINDOW, _         ' window style
           Sw\2-(Wid\2), _                 ' initial x position
           Sh\2-(Hgt\2), _                 ' initial y position
           Wid, _                          ' initial x size
           Hgt, _                          ' initial y size
           %NULL, _                        ' parent window handle
           %NULL, _                        ' window menu handle
           hInstance, _                    ' program instance handle
           ByVal %NULL)                    ' creation parameters

   '-------------------------

    hMnu = LoadMenu(hInstance,ByVal 10)
    SetMenu hWnd, hMnu

    ShowWindow hWnd, %SW_SHOW
    UpdateWindow hWnd

    FUNCTION = MessageLoop

END FUNCTION

' 

SUB global_init()

    LOCAL styl as DWORD
    LOCAL icce as INIT_COMMON_CONTROLSEX

  ' --------------------------------------
  ' comment out the styles you don't need.
  ' --------------------------------------
    icce.dwSize = SIZEOF(icce)                              ' set the structure size
    ! mov styl, 0                                           ' zero the variable
    ! or styl, %ICC_ANIMATE_CLASS                           ' OR as many styles as you need to it
    ! or styl, %ICC_BAR_CLASSES                             ' comment out the rest
    ! or styl, %ICC_COOL_CLASSES
    ! or styl, %ICC_DATE_CLASSES
    ! or styl, %ICC_HOTKEY_CLASS
    ! or styl, %ICC_INTERNET_CLASSES
    ! or styl, %ICC_LISTVIEW_CLASSES
    ! or styl, %ICC_PAGESCROLLER_CLASS
    ! or styl, %ICC_PROGRESS_CLASS
    ! or styl, %ICC_TAB_CLASSES
    ! or styl, %ICC_TREEVIEW_CLASSES
    ! or styl, %ICC_UPDOWN_CLASS
    ! or styl, %ICC_USEREX_CLASSES
    ! or styl, %ICC_WIN95_CLASSES
    icce.dwICC = styl
    InitCommonControlsEx icce                               ' initialise the common control library
  ' --------------------------------------

    hInstance = GetModuleHandle(ByVal %NULL)                ' application instance handle
    hIcon     = LoadIcon(hInstance,ByVal 2)                 ' application icon handle
    Sw        = GetSystemMetrics(%SM_CXSCREEN)              ' screen width
    Sh        = GetSystemMetrics(%SM_CYSCREEN)              ' screen height

    ClientColour = &H00555555                               ' set the colour for the client window

    tbbtnW   = 24       ' toolbar button width
    tbbtnH   = 24       ' toolbar button height
    rebarhgt = 30       ' set the rebar height to work with the toolbar
    vpadding = 4        ' vertical button padding in pixels
    hpadding = 4        ' horizontal button padding in pixels

  ' -------------------------------------------------
  ' load the toolbar button strip at its default size
  ' -------------------------------------------------
    hBitmap = LoadImage(hInstance,ByVal 5,%IMAGE_BITMAP,0,0, _
              %LR_DEFAULTSIZE or %LR_LOADTRANSPARENT or %LR_LOADMAP3DCOLORS)

  ' ----------------------------------------------------------------
  ' load the rebar background tile stretching it to the rebar height
  ' ----------------------------------------------------------------
    tbTile = LoadImage(hInstance,ByVal 800,%IMAGE_BITMAP,16,rebarhgt,%LR_DEFAULTCOLOR)

  ' -------------------------
  ' global file filter string
  ' -------------------------
    ffilter$ = chr$("All Files",0,"*.*",0, _
                    "Txt Files",0,"*.txt",0, _
                    "Ini Files",0,"*.ini",0,0)
END SUB

' 

FUNCTION MessageLoop() as DWORD

    LOCAL pst as DWORD                                      ' DWORD pointer for structure
    LOCAL msg as MSGSTRUCT                                  ' message structure

    pst = VarPtr(msg)                                       ' get pointer address
    ! jmp nxt_msg                                           ' jump into MsgLoop

  MsgLoop:
  ' ------------------------------------
  '    manual key processing here
  ' ------------------------------------
    Select Case msg.message
      case %WM_KEYUP
        CmpKey(%VK_SHIFT)                   ' CmpKey is a macro to test if a VK key is pressed
        ! je bypass1
        CmpKey(%VK_CONTROL)
        ! je bypass1
      ' --------------------------------
        Select Case msg.wParam
          case %VK_F1                       ' only F1
            msgbox "F1"
            ! jmp nxt_msg
        End Select
      ' --------------------------------
      bypass1:
      ' --------------------------------
        CmpKey(%VK_SHIFT)
        ! je bypass2
      ' --------------------------------
        Select Case msg.wParam
          case %VK_F1                       ' CONTROL & F1
            msgbox "CONTROL + F1"
            ! jmp nxt_msg
        End Select
      ' --------------------------------
      bypass2:
      ' --------------------------------
        CmpKey(%VK_CONTROL)
        ! je bypass3
      ' --------------------------------
        Select Case msg.wParam
          case %VK_F1                       ' SHIFT & F1
            msgbox "SHIFT + F1"
            ! jmp nxt_msg
        End Select
      ' --------------------------------
      bypass3:
    End Select
  ' ------------------------------------
    TranslateMessage ByVal pst
    DispatchMessage  ByVal pst
  nxt_msg:
    GetMessage ByVal pst,0,0,0
    ! test eax, eax
    ! jne MsgLoop

    FUNCTION = msg.wParam

END FUNCTION

' 

FUNCTION WndProc(ByVal hWin   as DWORD, _
                 ByVal Msg    as DWORD, _
                 ByVal wParam as LONG, _
                 ByVal lParam as LONG) as DWORD

    LOCAL hDC   as DWORD
    LOCAL rbh   as DWORD
    LOCAL sbh   as DWORD
    LOCAL Ps    as PAINTSTRUCT
    LOCAL Rct   as RECT

    Select Case as LONG Msg

      Case %WM_COMMAND
        Select Case as LONG wParam
        ' -----------------
        ' Tool Bar Messages
        ' -----------------
          Case 50
            MsgboxI hWin,"Tool Bar Command ID 50","Button 1",%MB_OK,2

          Case 51
            MsgboxI hWin,"Tool Bar Command ID 51","Button 2",%MB_OK,2

          Case 52
            MsgboxI hWin,"Tool Bar Command ID 52","Button 3",%MB_OK,2

          Case 54
            MsgboxI hWin,"Tool Bar Command ID 54","Button 5",%MB_OK,2

          Case 55
            MsgboxI hWin,"Tool Bar Command ID 55","Button 6",%MB_OK,2

          Case 56
            MsgboxI hWin,"Tool Bar Command ID 56","Button 7",%MB_OK,2

          Case 58
            MsgboxI hWin,"Tool Bar Command ID 58","Button 9",%MB_OK,2

          Case 59
            MsgboxI hWin,"Tool Bar Command ID 59","Button 10",%MB_OK,2

          Case 60
            MsgboxI hWin,"Tool Bar Command ID 60","Button 11",%MB_OK,2

        ' ------------------
        ' FILE MENU Messages
        ' ------------------
          Case 1010
          file_open:
            fname$ = GetFileName(hInstance,hWin,"Open File",ffilter$,"")
            If fname$ = "" Then
              Exit FUNCTION
            End if
            MessageBox hWin,ByCopy fname$,"Open File",%MB_OK

          Case 1020
          file_save:
            fname$ = SaveFileName(hInstance,hWin,"Save File As ...",ffilter$,"")
            If fname$ = "" Then
              Exit FUNCTION
            End if
            MessageBox hWin,ByCopy fname$,"Save File",%MB_OK

          Case 1090
          app_close:
            SendMessage hWin,%WM_SYSCOMMAND,%SC_CLOSE,ByVal %NULL

          Case 5000
            DialogBox hInstance,ByVal 200,hWnd,CodePtr(AboutProc)

        End Select

      Case %WM_CREATE
        hRebar  = rebar(hInstance,hWin)
        addband hInstance,hRebar
        hStatus = Create_Status_Bar(hWin)
        hClient = ClientWin(hInstance,hWin)

      Case %WM_SYSCOLORCHANGE

      Case %WM_SIZE
        GetWindowRect hRebar,Rct                    ' get the rebar height in pixels
        rbh = Rct.nBottom - Rct.nTop

        GetWindowRect hStatus,Rct                   ' get the status bar height in pixels
        sbh = Rct.nBottom - Rct.nTop

        GetClientRect hWin,Rct                      ' get the client rectangle dimensions
        MoveWindow hRebar,0,0,Rct.nRight,Rct.nBottom,%TRUE

        MoveWindow hStatus,0,0,0,0,%TRUE

        MoveWindow hClient,0,rbh,Rct.nRight, _      ' size client window into client area
                   Rct.nBottom - (rbh + sbh), %TRUE

      Case %WM_PAINT
        hDC = BeginPaint(hWin,Ps)
          GetClientRect hWin,Rct
          Paint_Proc hWin,hDC
        EndPaint hWin,Ps
        FUNCTION = 0
        Exit FUNCTION

      Case %WM_CLOSE

      Case %WM_DESTROY
        PostQuitMessage 0
        FUNCTION = 0
        Exit FUNCTION

    END Select

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 

SUB Paint_Proc(hWin as DWORD,hDC as DWORD)

    ' This SUB is for any GDI screen graphics

END SUB

' 

FUNCTION AboutProc( _
                  ByVal hDlg   as DWORD, _
                  ByVal Msg    as DWORD, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) as DWORD

    Select Case as LONG Msg
      Case %WM_INITDIALOG
        SetWindowText hDlg,"  About Windows Application Template"

        Advertise$ = cstr$("Windows Application Template\nCopyright (c) Your Name 2010-2020\n"+_
                           "youremail@yourIP.com All Rights Reserved\n\n"+_
                           "Write your own application description and advertising here. "+_
                           "Open this dialog with a resource editor or edit the RC file "+_
                           "manually to change the contents or layout of this Dialog.")

        SetWindowText(GetDlgItem(hDlg,65000),ByVal StrPtr(Advertise$))

      Case %WM_COMMAND
        Select Case wParam
          case 1000
          ! jmp outa_here
        End Select

      Case %WM_SYSCOMMAND
        Select Case wParam
          Case %SC_CLOSE
        outa_here:
          EndDialog hDlg, 0
        End Select

    End Select

    FUNCTION = 0

END FUNCTION

' 

FUNCTION MsgboxI(ByVal hParent as DWORD, _
                 Text$,Caption$,ByVal mbStyle as DWORD, _
                 ByVal IconID as DWORD) as LONG

    LOCAL mbp       as MSGBOXPARAMS

    mbp.cbSize              = SIZEOF(mbp)
    mbp.hwndOwner           = hParent
    mbp.hInstance           = GetModuleHandle(ByVal %NULL)
    mbp.lpszText            = StrPtr(Text$)
    mbp.lpszCaption         = StrPtr(Caption$)
    mbp.dwStyle             = mbStyle or %MB_USERICON
    mbp.lpszIcon            = IconID
    mbp.dwContextHelpId     = %NULL
    mbp.lpfnMsgBoxCallback  = %NULL
    mbp.dwLanguageId        = %NULL

    FUNCTION = MessageBoxIndirect(mbp)

END FUNCTION

' 

FUNCTION ClientWin(ByVal iinstance as DWORD,ByVal hParent as DWORD) as DWORD
                 
    LOCAL hndl         as DWORD
    LOCAL wcex         as WNDCLASSEX
    LOCAL szClassName  as ASCIIZ * 32
    LOCAL hBrush       as DWORD

    szClassName = "ClientClass"

    wcex.cbSize        = SIZEOF(wcex)
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CodePtr(ClientProc)
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = iinstance
    wcex.hIcon         = %NULL
    wcex.hCursor       = LoadCursor(%NULL,ByVal %IDC_ARROW)
    wcex.hbrBackground = CreateSolidBrush(ClientColour)
    wcex.lpszMenuName  = %NULL
    wcex.lpszClassName = VarPtr(szClassname)
    wcex.hIconSm       = %NULL

    RegisterClassEx wcex

    hndl = CreateWindowEx( _
           %WS_EX_LEFT, _
           szClassName, _
           ByVal %NULL, _
           %WS_CHILD, _
           0,0,0,0, _
           hParent, _
           %NULL, _
           iinstance, _
           ByVal %NULL)

    ShowWindow hndl, %SW_SHOW
    UpdateWindow hndl

  FUNCTION = hndl

END FUNCTION

' 

FUNCTION ClientProc( _
                 ByVal hWin   as DWORD, _
                 ByVal Msg    as DWORD, _
                 ByVal wParam as LONG, _
                 ByVal lParam as LONG) as DWORD

    Select Case as LONG Msg
  
    ' -------------------------------------------
    ' write your client area processing code here
    ' -------------------------------------------

    END Select

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 

